<!-- NoiseClassifyManage 噪音分类管理 -->
<template>
  <div class="full-page bg" element-loading-text="数据加载中..." element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(255,255,255, 0.5)" v-loading.fullscreen.lock="markLoading">
    <div class="search-container">
      <el-form ref="form" :model="parameter" label-width="auto">
        <el-row :gutter="10">
          <el-col :span="6">
            <el-form-item label="分类编码">
              <el-input v-model="querys[0].value" clearable placeholder="请输入分类编码"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="分类名称">
              <el-input v-model="querys[1].value" clearable placeholder="请输入分类名称"></el-input>
            </el-form-item>
          </el-col>
          <!-- <el-col :span="6">
                        <el-form-item label="噪音类别">
                            <dict-select
                                dictCode="ggbb_ssly"
                                :hasDefaultOption="true"
                                clearable
                                v-model="parameter.pilotField"
                                style="width: 100%"
                                @select="
                                    (val, obj) =>
                                        hanldeCommonSelect(val, obj, 'formInfo')
                                "
                                placeholder="请选择噪音类别"
                            />
                        </el-form-item>
                    </el-col> -->
          <el-col :span="2">
            <el-button icon="el-icon-search" type="primary" class="btn btn-plus" @click="getData(1)">
              {{ this.$t('common.search') }}
            </el-button>
          </el-col>
        </el-row>
      </el-form>
    </div>
    <el-row :gutter="10" :class="['main-table-container', 'flex']">
      <el-col :span="24" class="table-container" ref="contentPanel" style="padding: 20px">
        <div style="margin-bottom: 10px" ref="btnPanel">
          <el-button icon="el-icon-plus" type="primary" class="btn btn-plus" @click="handleAdd" v-methodauth="'NoiseClassifyManage_add'">
            添加
          </el-button>
          <el-button slot="reference" icon="el-icon-delete" type="danger" class="btn btn-delete"  v-methodauth="'NoiseClassifyManage_delete'"
            @click="handleDelete('deletes')" :disabled="deleteIds ? false : true">
            删除
          </el-button>
        </div>
        <div class="table-wrapper">
          <el-table stripe size="mini" v-loading="tableLoading" ref="tableData" :data="tableData" height="100%"
            :style="{ width: '100%' }" @selection-change="handleSelectionChange"
            :default-sort="{ prop: 'status', order: 'ascending' }">
            <el-table-column type="selection" width="55" align="center" :selectable="selectable"></el-table-column>
            <el-table-column type="index" label="序号" align="center">
            </el-table-column>
            <el-table-column prop="code" show-overflow-tooltip min-width="160" label="分类编码" align="center">
            </el-table-column>
            <el-table-column prop="name" show-overflow-tooltip min-width="160" label="分类名称" align="center">
            </el-table-column>

            <el-table-column prop="postalCode" show-overflow-tooltip min-width="260" label="适用区域" align="center">
            </el-table-column>
            <el-table-column prop="status" show-overflow-tooltip width="150" label="启用禁用" align="center">
              <template v-slot="{ row }">
                <el-switch v-model="row.status" @change="enableOrProhibit(row)" v-methodauth="'NoiseClassifyManage_status'"  active-value="0" inactive-value="1">
                </el-switch>
              </template>
            </el-table-column>
            <el-table-column show-overflow-tooltip align="center" min-width="180" label="操作">
              <template v-slot="{ row }">
                <el-link type="primary" :underline="false" style="margin: 0 10px" class="cloumn-btn" v-methodauth="'NoiseClassifyManage_edit'"
                  @click="handleEdit(row)">
                  编辑
                </el-link>
                <el-link type="danger" :underline="false" class="cloumn-btn" @click="handleDelete('delete', row)" v-methodauth="'NoiseClassifyManage_delete'">
                  删除
                </el-link>
              </template>
            </el-table-column>
          </el-table>
        </div>
        <pagination ref="paginationPanel" style="margin-top: 10px" :pageResult="pageResult"
          @size-change="handleSizeChange" @current-change="handleCurrentChange" />
        <NoiseClassifyDialog ref="formDialog" @getData="getData" />
      </el-col>
    </el-row>
  </div>
</template>
<script>
import pagination from '@/components/pagination'
import { TableMixin } from '@/mixins/tableMixin'
import NoiseClassify from '@/api/basicConfiguration/NoiseClassify'
import NoiseClassifyDialog from './components/NoiseClassifyDialog'
import utils from '@/utils.js'
export default {
  name: 'NoiseLevelManage',
  components: {
    pagination,
    NoiseClassifyDialog,
  },
  mixins: [TableMixin],
  data() {
    return {
      markLoading: false,
      tableMaxHeight: 400,
      tableData: [],
      pageResult: {
        page: 1,
        pageSize: 20,
        total: 0,
      },
      querys: [
        {
          group: 'main',
          operation: 'LIKE',
          parentGroup: '',
          property: 'code',
          relation: 'AND',
          value: '',
        },
        {
          group: 'main',
          operation: 'LIKE',
          parentGroup: '',
          property: 'name',
          relation: 'AND',
          value: '',
        },
      ],
      reqData: {
        querys: [],
        pageBean: {
          page: 1,
          pageSize: 20,
          showTotal: true,
        },
      },
      tableLoading: false,
      deleteIds: '',
      parameter: {
        size: 20,
        page: 1,
      },
    }
  },

  created() {
    this.getData()
  },
  methods: {
    selectable(row) {
      if (row.isDele === '1') {
        return false
      } else {
        return true
      }
    },
    //获取数据
    getData(page) {
      if (page) {
        this.reqData.pageBean.page = page
      }
      this.reqData.querys = []
      if (this.querys[0].value) {
        this.reqData.querys.push(this.querys[0])
      }
      if (this.querys[1].value) {
        this.reqData.querys.push(this.querys[1])
      }
      this.tableLoading = true
      NoiseClassify.dataQuery(this.reqData, (res) => {
        this.pageResult.total = res.total
        this.tableLoading = false
        this.tableData = res.rows
      })
    },

    // 编辑
    handleEdit(item) {
      this.$refs.formDialog.edit(item.id)
    },
    //启用or禁止
    enableOrProhibit(val) {
      NoiseClassify.enableDisable({ id: val.id }, (res) => {
        if (res.state) {
          this.$message.success(
            val.status === '0'
              ? '启用成功'
              : val.status === '1'
                ? '禁用成功'
                : ''
          )
          this.getData()
        }
      })
    },
    //获取删除数据id集合
    handleSelectionChange(val) {
      let arr = val.map((item) => item.id)
      this.deleteIds = arr.join(',')
      console.log(this.deleteIds)
    },
    //删除
    handleDelete(type, val) {
      console.log(val)
      this.$confirm('确认删除吗？', this.$t('common.tips'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'warning',
      }).then(() => {
        this.markLoading = true
        if (type === 'delete') {
          NoiseClassify.remove(val.id, (res) => {
            if (res.state) {
              this.getData()
              this.$message.success('删除成功')
              this.markLoading = false
            } else {
              this.markLoading = false
            }
          })
        } else {
          NoiseClassify.batchRemove(this.deleteIds, (res) => {
            if (res.state) {
              this.getData()
              this.$message.success('删除成功')
              this.markLoading = false
            } else {
              this.markLoading = false
            }
          })
        }
      })
    },
    handleSizeChange(val) {
      this.reqData.pageBean.pageSize = val
      this.getData()
    },
    handleCurrentChange(val) {
      this.reqData.pageBean.page = val
      this.getData()
    },
    getDictName(code, value) {
      return utils.getDictName(code, value)
    },
  },
}
</script>

<style lang="scss" scoped>
@import '~@/assets/css/element-variables.scss';
@import '~@/assets/css/common.scss';
</style>